/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.request.beans;

import cz.muni.fi.request.entities.Request;
import cz.muni.fi.request.entities.RequestState;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author Petr
 */
@Stateless
public class RequestBean implements RequestLocal {

    @PersistenceContext
    private EntityManager em;

    public Long createRequest(String name) {
        Request request = new Request();
        request.setName(name);
        request.setRequestState(RequestState.NEW);

        em.persist(request);

        return request.getId();
    }

    public void changeRequestState(Long id, RequestState state) {
        Request request = em.find(Request.class, id);
        request.setRequestState(state);
    }

    public List<Request> getAllRequests() {
        List<Request> requests = em.createNativeQuery("select from Request r", Request.class).getResultList();
        return requests;
    }

    public Request getRequestById(Long id) {
        return em.find(Request.class, id);
    }

    public void changeName(Long id, String name) {
        Request request = em.find(Request.class, id);
        request.setName(name);
    }
    
    void persist(Object object) {
        em.persist(object);
    }

    
}
